﻿using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace SfListViewSample
{
    public class ListViewBehavior : Behavior<SfListView>
    {
        #region Fields

        BookInfoViewModel ViewModel;
        SfListView ListView;

        #endregion

        #region Override Methods

        protected override void OnAttachedTo(SfListView listView)
        {
            ListView = listView;
            listView.Loaded += ListView_Loaded;
            base.OnAttachedTo(listView);
        }

        protected override void OnDetachingFrom(SfListView listView)
        {
            listView.Loaded -= ListView_Loaded;
            ViewModel.PropertyChanged -= ViewModel_PropertyChanged;
            ViewModel = null;
            ListView = null;
            base.OnDetachingFrom(listView);
        }

        #endregion

        #region Events

        private void ListView_Loaded(object sender, ListViewLoadedEventArgs e)
        {
            ViewModel = ListView.BindingContext as BookInfoViewModel;
            ViewModel.PropertyChanged += ViewModel_PropertyChanged;
            ViewModel.SelectedIndex = 2;
        }

        private void ViewModel_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "SelectedIndex")
            {
                ViewModel.SelectedItem = ViewModel.BookInfo[ViewModel.SelectedIndex];
                ListView.LayoutManager.ScrollToRowIndex(ViewModel.SelectedIndex, Syncfusion.ListView.XForms.ScrollToPosition.Center, false);
            }
        }

        #endregion
    }
}
